digexpr = /(.*?)(\d+)(.*)$/      # Replace last digits in a string
editor  = ENV['EDITOR'] || 'vi'

puts "Collecting all provisioned target names. This can take some time..."
sequences={}
MiqProvision.all.each do |p|
  result = digexpr.match(p.options[:vm_target_name].to_s.reverse)
  if result
    numstr = result[2].reverse
    pattern = "#{result[3].reverse}$n{#{numstr.size}}#{result[1].reverse}"
    sequences[pattern] = [sequences[pattern].to_i, numstr.to_i].max
  end
end

require 'tempfile'
modified_sequences = Tempfile.open('bfd3a7c7') do |t|
  t.write "# These are the sequence expressions and values to be updated. \n"
  t.write "# Modify the list as needed, then save and quit the editor. \n"
  t.write "# It will continue to update the database. \n"
  t.write sequences.to_yaml
  t.flush
  system(editor + ' ' + t.path)
  YAML.load(File.open(t.path))
end

existing_sequences = MiqRegion.my_region.naming_sequences.where(:source => "provisioning")
merged_sequences = Hash[existing_sequences.collect { |c| [c.name, c.value] }].merge(modified_sequences)

records =
  merged_sequences.collect do |seq, val|
    CustomAttribute.new(:name => seq, :value => val, :source => "provisioning")
  end

non_related = MiqRegion.my_region.naming_sequences.where("source != 'provisioning'")
MiqRegion.my_region.naming_sequences.replace(records + non_related)

puts "#{modified_sequences.size} sequence expressions have been updated."
